/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domain;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 *
 * @author student1
 */
public class Product implements Serializable, DomainObject{
    private Long id;
    private String name;
    private String description;
    private BigDecimal price;
    private Manufacturer manufacturer;
    private MeasurementUnit measurementUnit;

    public Product() {
    }

    public Product(Long id, String name, String description, BigDecimal price, Manufacturer manufacturer, MeasurementUnit measurementUnit) {
        this.id = id;
        this.name = name;
        this.description = description;
        this.price = price;
        this.manufacturer = manufacturer;
        this.measurementUnit = measurementUnit;
    }

    public MeasurementUnit getMeasurementUnit() {
        return measurementUnit;
    }

    public void setMeasurementUnit(MeasurementUnit measurementUnit) {
        this.measurementUnit = measurementUnit;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public Manufacturer getManufacturer() {
        return manufacturer;
    }

    public void setManufacturer(Manufacturer manufacturer) {
        this.manufacturer = manufacturer;
    }
    
    //metode za brokera
    @Override
    public String getTableName(){
        return "Product";
    }

    @Override
    public String getAttributeNamesForInsert() {
        return "id, name, description, manufacturer, price, measurementUnit";
    }

    @Override
    public String getAttributeValuesForInsert() {
        return id+", '"+name+"', '"+description+"', "+manufacturer.getId()+", "+price+", '"+measurementUnit.toString()+"'";
    }

    @Override
    public boolean isAutoincrement() {
        return false;
    }

    @Override
    public void setObjectId(Long id) {
        setId(id);
    }
    
    
    
}
