/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package database;

import domain.DomainObject;
import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class DatabaseBroker {
    Connection connection;
    
    public void connect() throws Exception{
        try {
            FileInputStream in=new FileInputStream("db.properties");
            Properties props=new Properties();
            props.load(in);
            String driver=props.getProperty("driver");
            String url=props.getProperty("url");
            String user=props.getProperty("user");
            String password=props.getProperty("password");
            
            Class.forName(driver);
            
            connection=DriverManager.getConnection(url, user, password);
            connection.setAutoCommit(false);
            System.out.println("Uspesno uspostavljena konekcija sa bazom!");
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska prilikom uspostavljanja konekcije sa bazom!\n"+ex.getMessage());
        }
    }
    
    public void disconnect() throws Exception {
        if(connection!=null){
            try {
                connection.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            throw new Exception("Greska prilikom raskidanja konekcije sa bazom!\n"+ex.getMessage());
            }
        }
    }
    
    public void commit() throws Exception{
        if(connection!=null){
            try {
                connection.commit();
            } catch (SQLException ex) {
                ex.printStackTrace();
            throw new Exception("Greska prilikom potvrdjivanja transakcije!\n"+ex.getMessage());
            }
        }
    }
    
    public void rollback() throws Exception{
        if(connection!=null){
            try {
                connection.rollback();
            } catch (SQLException ex) {
                ex.printStackTrace();
            throw new Exception("Greska prilikom ponistavanja transakcije!\n"+ex.getMessage());
            }
        }
    }
    
    public DomainObject insert(DomainObject odo) throws Exception{
        try {
            String upit="INSERT INTO "+odo.getTableName()+" ("+odo.getAttributeNamesForInsert()+") VALUES ("+odo.getAttributeValuesForInsert()+")";
            System.out.println(upit);
            Statement statement=connection.createStatement();
            statement.executeUpdate(upit, Statement.RETURN_GENERATED_KEYS);
            
            if(odo.isAutoincrement()){
                ResultSet rs=statement.getGeneratedKeys();
                if(rs.next()){
                    odo.setObjectId(rs.getLong(1));
                }
            }
            
            System.out.println("Uspesno kreiran "+odo.getTableName()+" u bazi!");
            
            
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new Exception(ex.getLocalizedMessage()+"Greska prilikom kreiranja "+odo.getTableName()+" u bazi!\n");
        }
        return odo;
    }
    
    
}
